import { IAlgorithm, IChromosome, ITermination, IIsland, IMigration } from '..';
export declare abstract class AlgorithmBase implements IAlgorithm {
    protected readonly _bestChanged: undefined | (() => void);
    private _chromosomes;
    private _fitness;
    protected constructor(_bestChanged?: undefined | (() => void));
    get generationNumber(): number;
    get offspringNumber(): number;
    get initialized(): boolean;
    get chromosomes(): Array<IChromosome>;
    abstract get islands(): Array<IIsland>;
    get migration(): IMigration | undefined;
    abstract get termination(): ITermination;
    get best(): IChromosome;
    get progress(): number;
    get hasReached(): boolean;
    private resetChromosomes;
    protected updateChromosomes(): void;
    reset(): void;
    protected performReset(): void;
    step(): void;
    protected performStep(): void;
}
