import { Acid, IChromosome } from '..';
export declare abstract class ChromosomeBase implements IChromosome {
    private acids;
    protected constructor(_length: number, skipLengthCheck?: boolean);
    createFromAcids(acids: Array<Acid>): void;
    abstract get fitness(): number;
    get length(): number;
    getAcid(index: number): Acid;
    setAcid(index: number, acid: Acid): void;
    deleteAcid(index: number): void;
    insertAcid(index: number, acid: Acid): void;
    abstract generateAcid(index: number): Acid;
    generateAcids(): void;
    abstract createNew(): ChromosomeBase;
    clone(): ChromosomeBase;
    copyFrom(from: ChromosomeBase): void;
    protected performCopyFrom(_from: IChromosome): void;
    mutation(index: number): void;
}
