import { IPopulation, IFitness, ISelection, ICrossover, IMutation, IReinsertion, IIsland, IChromosome } from '..';
export declare abstract class IslandBase implements IIsland {
    protected _generationNumber: number;
    protected _offspringNumber: number;
    private _initialized;
    get generationNumber(): number;
    get offspringNumber(): number;
    get initialized(): boolean;
    abstract get population(): IPopulation;
    abstract get fitness(): IFitness;
    abstract get selection(): ISelection;
    abstract get crossover(): ICrossover;
    abstract get mutation(): IMutation;
    abstract get reinsertion(): IReinsertion;
    reset(): void;
    protected performReset(): void;
    protected performMutate(chromosomes: Array<IChromosome>): void;
    protected performEvaluate(chromosomes: Array<IChromosome>): void;
    step(): void;
    protected performStep(): void;
}
