import { IAlgorithm, IChromosome, IMigration } from '..';
export declare abstract class MigrationBase implements IMigration {
    private prev;
    private time;
    get rate(): number;
    get interval(): number;
    init(): void;
    getCount(algorithm: IAlgorithm): number;
    getDestinations(algorithm: IAlgorithm): Array<number>;
    migrate(algorithm: IAlgorithm): void;
    protected static takeRandomChromosomes(chromosomes: Array<IChromosome>, count: number): Array<IChromosome>;
    protected getTakeCount(chromosomes: Array<IChromosome>): number;
    protected static splitChromosomes(chromosomes: Array<IChromosome>, count: number): {
        population: Array<IChromosome>;
        emigrants: Array<IChromosome>;
    };
    protected performMigrate(algorithm: IAlgorithm): void;
}
