"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MutationBase = void 0;
class MutationBase {
    // eslint-disable-next-line no-magic-numbers
    constructor(_probability, _deleteProbability = 0, _insertProbability = 0) {
        this._probability = _probability;
        this._deleteProbability = _deleteProbability;
        this._insertProbability = _insertProbability;
    }
    mutate(chromosome) {
        // eslint-disable-next-line no-magic-numbers
        if (this._deleteProbability > 0 && Math.random() < this._deleteProbability) {
            this.deleteAcid(chromosome);
        }
        [...Array(chromosome.length).keys()].forEach(index => {
            if (Math.random() < this._probability) {
                chromosome.mutation(index);
            }
        });
        // eslint-disable-next-line no-magic-numbers
        if (this._insertProbability > 0 && Math.random() < this._insertProbability) {
            this.insertAcid(chromosome);
        }
    }
    deleteAcid(chromosome) {
        // eslint-disable-next-line no-magic-numbers
        if (chromosome.length <= 1) {
            return;
        }
        chromosome.deleteAcid(Math.floor(Math.random() * chromosome.length));
    }
    insertAcid(chromosome) {
        // eslint-disable-next-line no-magic-numbers
        const index = Math.floor(Math.random() * (chromosome.length + 1));
        chromosome.insertAcid(index, chromosome.generateAcid(index));
    }
}
exports.MutationBase = MutationBase;
//# sourceMappingURL=MutationBase.js.map