"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SelectionBase = void 0;
class SelectionBase {
    takeRandom(chromosomes) {
        // eslint-disable-next-line no-magic-numbers
        return chromosomes.splice(Math.floor(Math.random() * chromosomes.length), 1)[0];
    }
    takeByFitness(chromosomes) {
        // eslint-disable-next-line no-magic-numbers
        const sum = chromosomes.reduce((acc, chromosome) => acc + chromosome.fitness, 0);
        let cumulative = 0.0;
        const rand = Math.random() * sum;
        for (let index = 0; index < chromosomes.length; index++) {
            const chromosome = chromosomes[index];
            cumulative += chromosome.fitness;
            if (cumulative >= rand) {
                // eslint-disable-next-line no-magic-numbers
                chromosomes.splice(index, 1);
                return chromosome;
            }
        }
        console.log(chromosomes);
        console.log(sum);
        console.log(rand);
        console.log(cumulative);
        throw new Error('Unexpected error');
    }
    takeByOrder(chromosomes) {
        // eslint-disable-next-line no-magic-numbers
        const sum = chromosomes.length * (chromosomes.length + 1) / 2;
        let cumulative = 0.0;
        const rand = Math.random() * sum;
        for (let index = 0; index < chromosomes.length; index++) {
            cumulative += chromosomes.length - index;
            if (cumulative >= rand) {
                const chromosome = chromosomes[index];
                // eslint-disable-next-line no-magic-numbers
                chromosomes.splice(index, 1);
                return chromosome;
            }
        }
        console.log(chromosomes);
        console.log(sum);
        console.log(rand);
        console.log(cumulative);
        throw new Error('Unexpected error');
    }
}
exports.SelectionBase = SelectionBase;
//# sourceMappingURL=SelectionBase.js.map